VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsValidasiControl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Class       : CValidateControl
' Description : List View Control Enhancer
' Source      : Total VB SourceBook 6
'

Private m_fInValidation As Boolean

Public Function Validate( _
  ctlIn As Control, _
  fTest As Boolean, _
  Optional strErrorMessage As String = "") _
  As Boolean
  ' Comments  : Check truth value of validation test and handle
  '             focus events to avoid deadlock LostFocus code
  ' Parameters: ctlIn - control to handle
  '             fTest - boolean value, normally the result of
  '             expression in the caller
  '             strErrorMessage - optional error message to display
  '             if the validation is false. Leave blank or
  '             omit to display your own message
  ' Returns   : True if the validation test fails or is bypassed because
  '             another control is being validated
  '             False if the validation test succeeds (meaning that an
  '             error was not raised.)
  ' Source    : Total VB SourceBook 6
  '
  On Error GoTo PROC_ERR

  ' if a different control is currently being validated, exit
  If m_fInValidation = False Then
  
    If fTest = False Then
      
      ' if test is false (failed validation), then set flag so that
      ' if another control receives a LostFocus event, it will not
      ' process its errors
      m_fInValidation = True
      
      ' display optional error message
      If strErrorMessage <> "" Then
        MsgBox strErrorMessage
      End If
      
      ' put focus onto the control. This might fire the LostFocus
      ' events of other controls. If so, those other controls should
      ' also be using this LostFocus validation handler
      ctlIn.SetFocus
      
      ' REQUIRED to allow the LostFocus events of other controls to
      ' complete processing
      DoEvents
      
      ' reset flag now that error handling is completed
      m_fInValidation = False
      
     ' an error was handled
      Validate = True
    End If
  
  Else
    ' no error was handled, or the test was bypassed because a
    ' different control was in the process of being handled
    Validate = False
  End If

PROC_EXIT:
  Exit Function

PROC_ERR:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , _
    "Validate"
  Resume PROC_EXIT

End Function


